
#ifndef SHELL_H
#define SHELL_H

#include "ntypes.h"
#include "hash.h"
#include "nmemory.h"
/*
// public type
typedef struct ShellFunction {
	const char *name;

} ShellFunction;
typedef char * (*Shell_TabCompletion_CB)( const char *funcName, const char *text, void *data );
	// number of arguments the function expects from the console
	// -number if at least number are expected but more are possible
	NSint argc;
		// whether the text executed is from the shell buffer or not
	Nbool fromCommandBuffer;

*/

typedef void (*Shell_Function_CB)( void );

void Shell_Init( void );
void Shell_Quit( void );

void Shell_AddText( const char *text );
void Shell_Execute( void );

Nbool Shell_FunctionExists( const char *name );
void Shell_RegisterFunction( const char *name, Shell_Function_CB callback, const char *description );
void Shell_UnregisterFunction( const char *name );

Hash_Sort_Item *Shell_GetList( void );

// functions used by commands

const char Shell_Function_Execute( const char *text );

NUint Shell_Function_GetArgC( void );
const char * Shell_Function_GetArg( NUint index ); 
void Shell_Function_Return( const char *returnText );

//void Shell_Function_Execute( const char *text, char **returnOut );

// private stuff
#include "shell_local.h"

// implementation of inline functions
inline Nbool Shell_FunctionExists( const char *name ) {
	return Shell_FindFunction( name ) != NULL;
}

inline NUint Shell_Function_GetArgC( void ) {
	assert( Shell.currentBlock );
	assert( Shell.currentBlock->currentStatement );
	return Shell.currentBlock->currentStatement->listSize;
}

inline const char * Shell_Function_GetArg( NUint index ) {
	assert( Shell.currentBlock );
	assert( Shell.currentBlock->currentStatement );
	assert( index <= Shell.currentBlock->currentStatement->listSize );
	return Shell.currentBlock->currentStatement->list[ index ];
}
#endif
